      subroutine change_string(string,sbstr0,sbstr1,sbstr2)
c----------------------------------------------------------------------c
c Replaces sbstr0 with sbstr1 in a character string if the criterion
c specified below is satisfied.
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c
c 10 Feb. 2016
c 19 Feb. 2016: a return command added after satisfying the second 
c criterion 
c----------------------------------------------------------------------c

      use extpart

      implicit none

      character(*) :: string,sbstr0,sbstr1,sbstr2
      character (80) :: ind,clx
      integer :: lsb0,lsb1,isb0,isb1,i,j

      lsb0=len_trim(sbstr0)
      isb0=index(string,trim(sbstr0))

      if (isb0 > 0) then
c 1st criterion:
       do i=1,nphot
        write(ind,'(i16)') exphot(i)
        clx='u'//trim(adjustl(ind))//','
        if (index(string,trim(clx)) > 0) then
         string=string(1:isb0-1)//trim(sbstr1)
     &                               //trim(string(isb0+lsb0:))
c 2nd criterion:
         do j=i+1,nphot
          write(ind,'(i16)') exphot(j)
          clx='u'//trim(adjustl(ind))//','
          if (index(string,trim(clx)) > 0) then
           lsb1=len_trim(sbstr1)
           isb1=index(string,trim(sbstr1))
           string=string(1:isb1-1)//trim(sbstr2)
     &                               //trim(string(isb1+lsb1:))
           return
          end if
         end do
        end if
       end do
      end if

      end subroutine change_string
