      program redcol1

      implicit none

      include 'colredx.f'
      integer :: i,j,k,ieq,ineq,itest
      character(20) :: ind,ind1,indp

      open(unit=30,file='colfacts.f',status='old',action='read')
      do k=1,iclr
       read(30,'(i10,i10,e20.12)') ix(k),jx(k),c2fd(k)
      end do
      close(30)

      open(unit=30,file='colinds.dat',status='replace',action='write')
      open(unit=31,file='colfcts.dat',status='replace',action='write')

      itest=0
      ineq=0
      do i=1,iclr
       if (ix(i) > 0) then
        itest=itest+1
        write(30,'(i10,i10)') ix(i),jx(i)
        ieq=0
        do j=i+1,iclr
         if (ix(j) > 0) then
          if (abs((c2fd(j)-c2fd(i))/c2fd(i)) < rcd) then
           ieq=ieq+1
           write(30,'(i10,i10)') ix(j),jx(j)
           ix(j)=0
          end if
         end if
        end do
        ineq=ineq+1
        write(*,'(i10,a,e20.12)') ieq+1,' equal factors ',c2fd(i)
        write(31,'(i10,e20.12)') ieq+1,c2fd(i)
        itest=itest+ieq
        if (itest == iclr) then
         write(*,'(a,i12)')'No more different colour factors beginning'
     &   //' from i=',i
         exit
        end if
       end if
      end do

      close(30)
      close(31)

      if (itest /= iclr) then
       write(*,'(a,i10,i10)')'redcol1.f: Error in colour matrix'//
     &  ' reduction:',itest,iclr
      else
       write(*,'(a,i10,a)') 'Colour matrix with',iclr,
     & ' nonzero elements'
       write(*,'(a,i10,a)') 'reduced to',ineq,' different factors'
      end if

      open(unit=30,file='colredm.f',status='replace',action='write')

      write(ind,'(i10)') iclr
      write(ind1,'(i10)') ineq
      write(30,'(a)') '      integer, parameter :: iclr='
     &  //trim(adjustl(ind))//',iclrx='//trim(adjustl(ind1))
      write(30,'(a)') '      integer, dimension(iclr) :: ix,jx'
      write(30,'(a)') '      integer, dimension(iclrx) :: iclm'
      write(indp,'(i10)') kind(1.d0)
      write(30,'(a)') '      real('//trim(adjustl(indp))//
     & '), dimension(iclrx) :: c2fd'

      close(30)

      open(unit=30,file='clrinf.f',status='replace',action='write')

      write(ind,'(i10)') iclr
      write(ind1,'(i10)') ineq
      write(30,'(a)') '      module clrinf'
      write(30,'(a)') ' '
      write(30,'(a)') '      integer, parameter :: iclr='
     &  //trim(adjustl(ind))//',iclrx='//trim(adjustl(ind1))
      write(30,'(a)') ' '
      write(30,'(a)') '      end module clrinf'

      close(30)

      end
