      subroutine wrkinprms(nfsp)

      use psgen_info
c      use extpart
c      use tchkins
c      use schkins
c      use gchkins

      integer :: nfsp
      character(80) :: ind
      character(160) :: cm

      open(unit=20,file='kinparams.f',status='replace',action='write')

      write(20,'(a)')'      module kinparams'
      write(20,'(a)') ' '
      write(20,'(a)')'      use inprms'
      write(20,'(a)') ' '
      if (iqprec == 1) then
       write(20,'(a)')'      integer, parameter :: iqprec=1'
       write(20,'(a)')'      integer, parameter :: xp=kind(1.q0)'
      else
       write(20,'(a)')'      integer, parameter :: iqprec=0'
       write(20,'(a)')'      integer, parameter :: xp=kind(1.d0)'
      end if
      write(ind,'(i4)') nptcl
      write(20,'(a)') '      integer, parameter :: nexp='//
     &                                            trim(adjustl(ind))   
      write(ind,'(i4)') nfsp
      write(20,'(a)') '      integer, parameter :: nfsp='//
     &                                            trim(adjustl(ind))   
      write(ind,'(i4)') igind2
      write(20,'(a)') '      integer, parameter :: igind='//
     &                                            trim(adjustl(ind))   
      write(20,'(a)') '      include ''nkin_decl.f'''
      write(20,'(a)') '      real(xp) :: m(nexp)'
      write(20,'(a)') '      character(10) :: expc(nexp)'
      write(20,'(a)') '      character(1) :: expl(nexp)'
      write(20,'(a)') ' '
      write(20,'(a)') '      integer :: iwkin(nkin)'
      write(20,'(a)') '      real(kind(1.d0)) :: aw(nkin)'
      write(20,'(a)') '      real(kind(1.d0)) :: aw_w(nkin,3)'
      write(20,'(a)') ' '
      write(20,'(a)') '      contains'
      write(20,'(a)') '       subroutine exp_masses'
      cm='       m=(/'                        ! 4 May 2023 >
c      write(20,'(a)') '        m=(/'
c      write(20,'(a$)') '     &'
      do i=1,nptcl
       if (i < nptcl) then
        if(iqprec == 1) then
         cm=trim(cm)//trim(cmass(i))//'_qp,'
c         write(20,'(a$)') trim(f(i)%m)//'_qp,'
        else
         cm=trim(cm)//trim(cmass(i))//','
c         write(20,'(a$)') trim(f(i)%m)//','
        end if
       else
        if(iqprec == 1) then
         cm=trim(cm)//trim(cmass(i))//'_qp/)'
c         write(20,'(a)') trim(f(i)%m)//'_qp/)'
        else
         cm=trim(cm)//trim(cmass(i))//'/)'
c         write(20,'(a)') trim(f(i)%m)//'/)'
        end if
       end if
      end do
      call wrt72(20,cm)                      ! 4 May 2023 <
      write(20,'(a)') '      end subroutine exp_masses'
      write(20,'(a)') '       subroutine exp_names'
      do i=1,nptcl
       write(ind,'(i4)') i
       write(20,'(a)') '        expc('//trim(adjustl(ind))//')='
     &                 //''''//trim(ptcl(i))//''''
       write(20,'(a)') '        expl('//trim(adjustl(ind))//')='
     &                 //''''//trim(ptclt(i))//''''
      end do
      write(20,'(a)') '       end subroutine exp_names'
      write(20,'(a)') ' '
      write(20,'(a)')'      end module kinparams'

      close(20)

      end


